#include "Book.h"
#include "BookShelf.h"
#include "BookShelfIterator.h"

BookShelf::BookShelf(int maxSize)
    : m_last(0),
      m_books(new Book*[maxSize]),
      m_maxSize(maxSize)
{
}

BookShelf::~BookShelf()
{
    delete[] m_books;
}

Book *BookShelf::getBookAt(int index)
{
    if (index < m_maxSize)
        return m_books[index];
    else
        return 0;
}

void BookShelf::appendBook(Book *book)
{
    m_books[m_last++] = book;
}

int BookShelf::getLength()
{
    return m_last;
}

Iterator *BookShelf::iterator()
{
    return (Iterator *)new BookShelfIterator(this);
}